<?php
/* **************************************************************************** *

 * cor-add-user.php								*
 * @package	Core								*
 * @copyright:	Copyright (c) 2007 - 2008 Ragnar.cz. All rights reserved	*
 * @license	GNU/GPL http://www.gnu.org/copyleft/gpl.html			*
 
 * Albireo is free software! You can redistribute it and/or modify it under	*
 * the terms of the GNU Affero General Public License as published		*
 * by the Free Software Foundation, either version 3 of the License, or		*
 * (at your option) any later version.						*

 *	This program is distributed in the hope that it will be useful,		*
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of		*
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the		*
 *	GNU Affero General Public License for more details.			*

 This script description:
 Page for adding users.

 Properties:
    array $page			// contains changes for array $page in ScriptPage
 	
 Public Methods:
    none
 	
 * **************************************************************************** */

class addUser {

    public $page = array ();

    public function __construct ()
    {

        if ( isset ( $_GET [ "checknick" ] ) ) {
            $this -> page [ "text" ] .= $this -> check_nick ();
        } elseif ( isset ( $_POST [ "nick" ], $_POST [ "fullname" ], $_POST [ "password" ], $_POST [ "password2" ], $_POST [ "usergroup" ], $_POST [ "language" ]  ) ) {
            $this -> page [ "text" ] .= self::addNewUser ();
            $this -> page [ "text" ] .= '<img src="images/users-icons/free-icons/blue-user-big.jpg" alt="'. _( "Modrá uživatelská ikona" ) .'" />
            <hr class="cleaner" /><input type="button" class="dialoguebutton" onclick="location.reload(true);" value="'. _( "Zavřít" ) .'" />';
        } else {
            $this -> page [ "text" ] .= self::addUserForm ();
        }

    } // end __construct

    private function check_nick ()
    {
        $nick = htmlspecialchars ( $_GET [ "checknick" ] );
        if ( Database::connection () -> getResult ( "SELECT `id` FROM `users` WHERE `nick`='$nick' LIMIT 1;" ) ) {
            return '<strong class="warning">'. _( "zadané" ) .'</strong>';
        } else {
            return '<strong class="success">'. _( "volné" ) .'</strong>';
        }
    } // end check_nick

    public static function addUserForm ()
    {

    	$password = md5 ( $_POST [ "pass" ] );
    	$nick = htmlspecialchars ( $_POST [ "nick" ] );
    	$fullname = htmlspecialchars ( $_POST [ "fullname" ] );
    	$language = htmlspecialchars ( $_POST [ "language" ] );
    	$usergroup = (int) $_POST [ "usergroup" ];

	$form .= '
	<form action="'. Tools::getFullPage () .'" method="post" id="CreateUserForm" enctype="application/x-www-form-urlencoded">
	    	<fieldset>
     	    	    <legend>'. _( "Vytvoření nového uživatele" ) .'</legend>
     	    	    <label for="nick">'. _( "Přezdívka" ) .': </label><input type="text" name="nick" id="nick" maxlength="20" value="'. $nick .'" /><span id="checknick">&nbsp;</span><br />
     	    	    <label for="fullname">'. _( "Občanské jméno" ) .': </label><input type="text" name="fullname" maxlength="40" value="'. $fullname .'" /><br />
             	    <label for="password">'. _( "Heslo" ) .': </label><input type="password" size="15" name="password" maxlength="25" onkeyup="$(\'#passwordStrength\').css(\'margin-left\',\'135px\');passwordStrength(this.value,\'passwordStrength\');" />
             	    <span id="passwordStrength">&nbsp;</span><br />
             	    <label for="password2">'. _( "Ověření hesla" ) .': </label><input type="password" size="15" name="password2" maxlength="25" /><br />';

	if ( isset ( $_GET [ "primarygroupid" ] ) || isset ( $_GET [ "usergroupid" ] ) ) {
	    if ( User::session () -> getPrimaryGroup () > ( (int) $_GET [ "primarygroupid" ] ) )
	    	Error::ticket () -> notice ( 'cor00032', 'in '.__FILE__.' on line '.__LINE__, User::session () -> getId () );
	    $form .= '<input type="hidden" name="usergroup" value="'. (int) $_GET [ "primarygroupid" ] .'" />
	              <input type="hidden" name="secondaryusergroup" value="'. (int) $_GET [ "usergroupid" ] .'" />';
	} else {
	    $form .= '<label for="usergroup">'. _( 'Skupina' ) .': </label>
	    	<select name="usergroup">';

		$primaryGroup = User::session () -> getPrimaryGroup ();
		if ( $primaryGroup == 1 ) $form .= '<option value="1">'. _( "Administrátoři" ) .'</option>';
		if ( $primaryGroup <= 2 ) $form .= '<option value="2">'. _( "Webmasteři" ) .'</option>';
		if ( $primaryGroup <= 3 ) $form .= '<option value="3">'. _( "Spisovatelé" ) .'</option>';
		if ( $primaryGroup <= 4 ) $form .= '<option value="4">'. _( "Uživatelé" ) .'</option>';

	    $form .= '</select><br />';
	}

        $form .= '<label for="language">'. ( "Jazyk" ) .': </label><select name="language">
             	    	<option value="cs"'. ( ( $language == "cs" ) ? " selected=\"selected\"" : "" ) .'>čeština</option>
             	    </select><br />
             	    <input class="dialoguebutton" type="submit" value="'. ( "Vytvořit uživatele" ) .'" onclick="changeDialogueByPost(\''. Tools::getPage () .'.xml\',\'CreateUserForm\');return false;" />
             	</fieldset>
            </form>
            <script type="text/javascript">
				$( "#checknick" ).css ( "margin-left", "0px" );
                /*function checkname () {
                    changeIdByGET ( "'. Tools::getPage() .'.xml?checknick="+$("#nick").val(), "checknick" );
                    //$(\'#nick\').unbind(\'change\',checkname);
                }
                $( "#nick" ).change( checkname );*/
            </script>';

        return $form;

    } // end addUserForm

    public static function addNewUser ()
    {
    	if ( empty ( $_POST [ "nick" ] ) || empty ( $_POST [ "password" ] ) || empty ( $_POST [ "password2" ] ) ) {
    	    return '<p><strong class="warning">'. _( "Jedno nebo více z políček Nick, Heslo nebo Ověření hesla nebylo vyplněno." ) .'</strong></p>';
    	}

    	if ( strlen ( $_POST [ "password" ] ) < 6 ) {
    	    return '<p><strong class="warning">'. _( "Délka hesla musí být minimálně 6 znaků." ) .'</strong></p>';
    	}
    	
    	if ( $_POST [ "password" ] != $_POST [ "password2" ] ) {
    	    Error::ticket () -> notice ( 'cor00017', 'in '.__FILE__.' on line '.__LINE__, $nick );
    	    return false;
    	}
    	
    	$password = md5 ( addslashes ( $_POST [ "password" ] ) );
    	$nick = htmlspecialchars ( $_POST [ "nick" ] );
    	$fullname = htmlspecialchars ( $_POST [ "fullname" ] );
    	$language = htmlspecialchars ( $_POST [ "language" ] );
    	$usergroup = (int) $_POST [ "usergroup" ];
        $dir_name = $nick;
        $bad_chars = array ( " ", "%", "&", "?", ";", ",", "\'", "`", "\"", "á", "ä", "č", "ď", "é", "ě", "í", "ĺ", "ľ", "ň", "ó", "ô", "ŕ", "ř", "š", "ť", "ú", "ů", "ý", "ž" );
		$asci_chars = array ( "-", "", "", "", "", "", "", "", "", "a", "a", "c", "d", "e", "e", "i", "l", "l", "n", "o", "o", "r", "r", "s", "t", "u", "u", "y", "z" );
        $dir_name = urlencode ( str_replace ( $bad_chars, $asci_chars, $dir_name ) );

        if ( User::session () -> getPrimaryGroup () > $usergroup )
	    	Error::ticket () -> notice ( 'cor00032', 'in '.__FILE__.' on line '.__LINE__, User::session () -> getId () );

    	if ( file_exists ( "home/".$dir_name ) || Database::connection () -> getResult ( "SELECT `id` FROM `users` WHERE `nick`='$nick';" ) ) {
    	    return '<p><strong class="warning">'. $nick . ' - '. _( "uživatel s touto přezdívkou již existuje." ) .'</strong></p>';
    	}

    	if ( Database::connection () -> query ( "INSERT INTO users VALUES (0, '$nick', '$password', '$fullname', CURRENT_TIMESTAMP (),  0, '$language');" ) ) {
    	    if ( Database::connection () -> query ( "INSERT INTO membersofgroups VALUES ( LAST_INSERT_ID(), $usergroup );" ) ) {
                if ( $usergroup != 4 ) {
                    if ( !( mkdir ( "home/".$dir_name ) && Database::connection () -> query ( "REPLACE INTO `drivefilesv2` (`url`,`physicalname`,`author`,`groupid`,`access`) VALUES ('/home/','$dir_name',LAST_INSERT_ID(),1,'wr0');" ) ) ) {
                        return '<p><strong class="warning">'. $nick . ' - '. _( "uživatel vytvořen, ale nepodařilo se mu vytvořit osobní složku." ) .'</strong></p>';
                    }
                }
    	    	if ( isset ( $_POST [ "secondaryusergroup" ] ) ) {
    	    	   if ( Database::connection () -> query ( "INSERT INTO membersofgroups VALUES ( LAST_INSERT_ID(), ". (int) $_POST [ "secondaryusergroup" ] ." );" ) ) {
    	    	    	if ( !self::createUserMenu (  Database::connection () -> getResult ( "SELECT LAST_INSERT_ID();" ), (int) $_POST [ "secondaryusergroup" ] ) ) {
    	    	    	    return '<p><strong class="warning">'. $nick . ' - '. _( "uživatel byl úspěšně vytvořen, ale nepodařilo se pro něj vytvořit menu. Bude pro něj proto použito defaultní menu jeho primární skupiny." ) .'</strong></p>';
    	    	    	} else {
    	    	    	    return '<p><strong class="success">'. $nick . ' - '. _( "uživatel byl úspěšně vytvořen") .'.</strong></p>';
    	    	    	}
    	    	    } else {
    	    	    	return '<p><strong class="warning">'. $nick . ' - '. _( "uživatel vytvořen, ale nepodařilo se mu přiřadit sekundární uživatelskou skupinu. O problému uvědomte administrátora." ) .'</strong></p>';
    	    	    }
    	    	} else {
    	    	    if ( !self::createUserMenu (  Database::connection () -> getResult ( "SELECT LAST_INSERT_ID();" ), $usergroup ) ) {
    	    	    	return '<p><strong class="warning">'. $nick . ' - '. _( "uživatel byl úspěšně vytvořen, ale nepodařilo se pro něj vytvořit menu. Bude pro něj proto použito defaultní menu jeho primární skupiny." ) .'</strong></p>';
    	    	    } else {
    	    	    	return '<p><strong class="success">'. $nick . ' - '. _( "uživatel byl úspěšně vytvořen") .'.</strong></p>';
    	    	    }
    	    	}
    	    } else {
    	    	return '<p><strong class="warning">'. $nick . ' - '. _( "uživatel vložen do databáze, ale nepodařilo se mu přiřadit uživatelskou skupinu" ) .'!</strong></p>';
    	    }
    	} else {
    	    Error::ticket () -> notice ( 'cor00018', 'in '.__FILE__.' on line '.__LINE__, $nick );
    	}
    } // end addNewUser

    public static function createUserMenu ( $userid, $groupid )
    {
    	$upmenu = Database::connection () -> fetchall_assoc ( "SELECT * FROM `groupsappmenus` WHERE `groupid`=$groupid;" );
    	foreach ( $upmenu as $menuIcon ) {
    	    if ( !Database::connection () -> query ( "INSERT INTO `usersappmenus` VALUES ($userid, '". $menuIcon [ "anchor" ] ."', '". $menuIcon [ "file" ] ."', '". $menuIcon [ "icon" ] ."', '". $menuIcon [ "sequence" ] ."');" ) ) {
    	    	@Database::connection () -> query ( "DELETE FROM `usersappmenus` WHERE `userid`=$userid;" );
    	    	return false;
    	    }
    	}
    	return true;
    }

}

$addUser = new addUser ();
$page = $addUser -> page;
?>